
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ShipmentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const shipments = await db.shipments.create(
            {
                id: data.id || undefined,
        
        shipment_number: data.shipment_number
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        packed_at: data.packed_at
        ||
        null
            ,
            
        shipped_at: data.shipped_at
        ||
        null
            ,
            
        delivered_at: data.delivered_at
        ||
        null
            ,
            
        carrier: data.carrier
        ||
        null
            ,
            
        tracking_number: data.tracking_number
        ||
        null
            ,
            
        ship_to_address: data.ship_to_address
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await shipments.setSales_order( data.sales_order || null, {
            transaction,
        });
        
        await shipments.setFrom_warehouse( data.from_warehouse || null, {
            transaction,
        });
        
        await shipments.setShipped_by( data.shipped_by || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.shipments.getTableName(),
                belongsToColumn: 'documents',
                belongsToId: shipments.id,
            },
            data.documents,
            options,
        );
        

        return shipments;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const shipmentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                shipment_number: item.shipment_number
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                packed_at: item.packed_at
            ||
            null
            ,
            
                shipped_at: item.shipped_at
            ||
            null
            ,
            
                delivered_at: item.delivered_at
            ||
            null
            ,
            
                carrier: item.carrier
            ||
            null
            ,
            
                tracking_number: item.tracking_number
            ||
            null
            ,
            
                ship_to_address: item.ship_to_address
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const shipments = await db.shipments.bulkCreate(shipmentsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < shipments.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.shipments.getTableName(),
                    belongsToColumn: 'documents',
                    belongsToId: shipments[i].id,
                },
                data[i].documents,
                options,
            );
        }
        

        return shipments;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const shipments = await db.shipments.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.shipment_number !== undefined) updatePayload.shipment_number = data.shipment_number;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.packed_at !== undefined) updatePayload.packed_at = data.packed_at;
        
        
        if (data.shipped_at !== undefined) updatePayload.shipped_at = data.shipped_at;
        
        
        if (data.delivered_at !== undefined) updatePayload.delivered_at = data.delivered_at;
        
        
        if (data.carrier !== undefined) updatePayload.carrier = data.carrier;
        
        
        if (data.tracking_number !== undefined) updatePayload.tracking_number = data.tracking_number;
        
        
        if (data.ship_to_address !== undefined) updatePayload.ship_to_address = data.ship_to_address;
        
        
        updatePayload.updatedById = currentUser.id;

        await shipments.update(updatePayload, {transaction});

        
        
        if (data.sales_order !== undefined) {
            await shipments.setSales_order(
              
              data.sales_order,
              
              { transaction }
            );
        }
        
        if (data.from_warehouse !== undefined) {
            await shipments.setFrom_warehouse(
              
              data.from_warehouse,
              
              { transaction }
            );
        }
        
        if (data.shipped_by !== undefined) {
            await shipments.setShipped_by(
              
              data.shipped_by,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.shipments.getTableName(),
                belongsToColumn: 'documents',
                belongsToId: shipments.id,
            },
            data.documents,
            options,
        );
        

        return shipments;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const shipments = await db.shipments.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of shipments) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of shipments) {
                await record.destroy({transaction});
            }
        });


        return shipments;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const shipments = await db.shipments.findByPk(id, options);

        await shipments.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await shipments.destroy({
            transaction
        });

        return shipments;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const shipments = await db.shipments.findOne(
            { where },
            { transaction },
        );

        if (!shipments) {
            return shipments;
        }

        const output = shipments.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.shipment_lines_shipment = await shipments.getShipment_lines_shipment({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        output.sales_order = await shipments.getSales_order({
            transaction
        });
        
        
        output.from_warehouse = await shipments.getFrom_warehouse({
            transaction
        });
        
        
        output.shipped_by = await shipments.getShipped_by({
            transaction
        });
        
        
        output.documents = await shipments.getDocuments({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.sales_orders,
        as: 'sales_order',
        
        where: filter.sales_order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.sales_order.split('|').map(term => Utils.uuid(term)) } },
            {
              so_number: {
                [Op.or]: filter.sales_order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.warehouses,
        as: 'from_warehouse',
        
        where: filter.from_warehouse ? {
          [Op.or]: [
            { id: { [Op.in]: filter.from_warehouse.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.from_warehouse.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'shipped_by',
        
        where: filter.shipped_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.shipped_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.shipped_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'documents',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.shipment_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'shipments',
                        'shipment_number',
                        filter.shipment_number,
                    ),
                };
            }
            
            if (filter.carrier) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'shipments',
                        'carrier',
                        filter.carrier,
                    ),
                };
            }
            
            if (filter.tracking_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'shipments',
                        'tracking_number',
                        filter.tracking_number,
                    ),
                };
            }
            
            if (filter.ship_to_address) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'shipments',
                        'ship_to_address',
                        filter.ship_to_address,
                    ),
                };
            }
            

            
            

            
            if (filter.packed_atRange) {
                const [start, end] = filter.packed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    packed_at: {
                    ...where.packed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    packed_at: {
                    ...where.packed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.shipped_atRange) {
                const [start, end] = filter.shipped_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    shipped_at: {
                    ...where.shipped_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    shipped_at: {
                    ...where.shipped_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.delivered_atRange) {
                const [start, end] = filter.delivered_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    delivered_at: {
                    ...where.delivered_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    delivered_at: {
                    ...where.delivered_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.shipments.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'shipments',
                        'shipment_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.shipments.findAll({
            attributes: [ 'id', 'shipment_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['shipment_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.shipment_number,
        }));
    }

    
};

